%% Evaluate Multi-task Graph Classification, Xte, Graph;
function [Err,ypred,AUC,acc,auc]=EvalMultiTask_Graph(Xte,Yte,model)

Weights=model.normKernelWeight;
WC=model.WC;
mu=model.mu;
Alpsup=model.w;
w0=model.bsvm;
pos=model.pos;

nbtasks=length(Xte);
Err=0;
ypredv=[];
yt=[];
for t=1:nbtasks
    
    xte=Xte{t};
    %nTrain = size(WC(1).F{t},1);
    nTrain = length(pos{t});
    Kt=mklkernel_d(xte,WC,Weights{t},mu(t,:),pos{t},t,nTrain);
   % Kt=Kt(pos{t},:);
    
    ypred{t}=Kt*Alpsup{t}+w0{t};
    %Err=Err+ 1/nbtasks*mean(sign(ypred{t})~=Yte{t});
    acc(t)=1-sum(sign(ypred{t})~=Yte{t})/length(ypred{t});
    
    ypredv=[ypredv;ypred{t}];
    yt=[yt; Yte{t}];
    auc(t) = rocscore (ypred{t},Yte{t});
end;
Err=1-mean(acc);
AUC=mean(auc);
end

function [K] = mklkernel_d(Xte,WC,Weight,mu,pos,tIndex,nTrain)
    
    import util.*;
    nTest = Xte.size();
    [nbk]=length(WC);
    %disp(['nb kernels:',num2str(nbk)])
    K=zeros(nTest,nTrain);
    for i=1:nbk;
        
        F1 = WC(i).F{tIndex};
        F1 = F1(pos,:);
        dall = WC(i).comIndex + WC(i).taskIndex(tIndex,:)+WC(i).auxIndex(tIndex,:);
        ind = find(dall);
        
        subg = java.util.ArrayList;
        for j = 1:nnz(ind)
            subg.add(WC(i).subgraphs.get(ind(j)-1));
        end
        
        F2 = GraphUtils.graph2Vector(Xte,subg);
        
        Kr = F2 * F1';

        Kr=Kr*Weight(i); %if each kernel has weight, we need to used
      %  it
        K=K+ Kr*mu(i);            

        
    end;    
end

