function [Err,ypred,AUC,acc,auc]=EvalMultiTask_d(X,Xte,Yte,model)

Weights=model.normKernelWeight;
WC=model.WC;
mu=model.mu;
Alpsup=model.w;
w0=model.bsvm;
pos=model.pos;
linear = model.linear;


nbtasks=length(X);
Err=0;
ypredv=[];
yt=[];
for t=1:nbtasks
    xsup=X{t}(pos{t},:);
    xtest=Xte{t};
    
     if isfield(model,'AllWC') %for task specified features, the selected features are different
         a=model.AllWC{t};
     else
         a=WC;
     end
    %WC=model.AllWC{t};
    v=mu(t,:);
    w=Weights{t};
    Kt=mklkernel_d(xtest,a,w,xsup,v,linear); 
    
    ypred{t}=Kt*Alpsup{t}+w0{t};
    Err=Err+ 1/nbtasks*mean(sign(ypred{t})~=Yte{t});
    acc(t)=1-sum(sign(ypred{t})~=Yte{t})/length(ypred{t});
    
    ypredv=[ypredv;ypred{t}];
    yt=[yt; Yte{t}];
    
    auc(t) = rocscore (ypred{t},Yte{t});
    
end;
%AUC=svmroccurve(ypredv,yt);
AUC=mean(auc);
end

function [K] = mklkernel_d(xapp,WC,Weight,xsup,mu,linear)
    kernel='poly';
    kerneloption=1;
    [nbk]=size(WC);
    K=zeros(size(xapp,1),size(xsup,1));
    for i=1:nbk;
        if ~linear %calculate each kernel, and then sum up
            variables=find(WC(i,:));
           
            Kr=svmkernel(xapp(:,variables),kernel,kerneloption, xsup(:,variables));
           %Kr=normalizekernel(xapp(:,variables),kernel,kerneloption, xsup(:,variables));           
                        
            Kr=Kr*Weight(i); %if each kernel has weight, we need to used
          %  it
            K=K+ Kr*mu(i);
        else
            nsup=size(xsup,1);
            d_bar=mu .*Weight' * WC;
            %d_bar=mu  * WC;

            dIndex=find(d_bar);
            dpro = d_bar(dIndex);
            Xtemp = xapp(:,dIndex);
            Xsuptemp=xsup(:,dIndex) .* repmat(dpro,nsup,1);
            K=svmkernel(Xtemp,kernel,kerneloption, Xsuptemp);

           % K=normalizekernel(Xtemp,kernel,kerneloption, Xsuptemp);

            %K = Xtemp * Xsuptemp'; 
        end
        
    end;    
end
