function [X,Y,Xte,Yte,Xval,Yval,setting]=GetMultiTaskFeaturesTspSyn(nbtasks,nbfeatrel,nbfeattot,nbapp,nbtest,sigmas,nbval,Kt,Ka)
% returns a cell containing several tasks for mutitask learnbing

% nbtasks = opt.nbtasks;
% nbfeatrel = opt.nbfeatrel;
% nbfeattot=opt.nbfeattot;
% nbapp=opt.nbapp;
% nbtest=opt.nbtest;
% sigmas=opt.sigmas;
% nbval=opt.nbval;
% Kt=opt.Kt;
% Ka=opt.Ka;

%initialisation mémoire
X=cell(nbtasks,1);
Xte=cell(nbtasks,1);
Y=cell(nbtasks,1);
Yte=cell(nbtasks,1);
Xval=cell(nbtasks,1);
Yval=cell(nbtasks,1);


if ~iscell(sigmas)
    for i=1:nbtasks
        sigmaaux{i}=sigmas;
    end;
    sigmas=sigmaaux;
end;

ts = sum(Kt);
comIndex=1:nbfeatrel; %the first set features are for common feature index;
%reverveIndex = nbfeattot-ts+1:nbfeatot; %the last ts features are for task specific feature
auxIndex = cell(nbtasks,1);
taskIndex = cell(nbtasks,1);

 for i=1:nbtasks
    P=randperm(nbfeattot-nbfeatrel-ts,Ka(i)); %random select Kt(t) features as auxiliary feature
    auxIndex{i}=sort(P+nbfeatrel); % feature index for auxiliary feature
    
    startIndex = nbfeattot-ts+1+sum(Kt(1:i-1));
    endIndex = nbfeattot-ts+1+sum(Kt(1:i))-1;
    taskIndex{i} =  startIndex:endIndex;
    
  end
 
 for i=1:nbtasks
    relevantIndex=[comIndex,auxIndex{i},taskIndex{i}];
    [X{i},Y{i},Xte{i},Yte{i},Xval{i},Yval{i}]=GetFeatureSelectionData(relevantIndex,nbfeattot,nbapp,nbtest,sigmas{i},nbval);    
 end
 
setting.comIndex=comIndex;
setting.taskIndex=taskIndex;
setting.auxIndex=auxIndex;


function [X,Y,Xte,Yte,Xval,Yval]=GetFeatureSelectionData(nbfeatrelIndex, nbfeattot,nbapp,nbtest,sigmas,nbval)
% returns datas with nbfeatrel relevant canals and nbfeattot total canals,
% features are centered on -1 or 1 and sigma for each relevant canal can be selected

tot = 1:nbfeattot;

feaIreIndex=setdiff(tot,nbfeatrelIndex);
nbfeatrel = length(nbfeatrelIndex);
if nargin < 6
    nbval=0;
end;

if nargin<5
     sigmas=ones(nbfeatrel,1);
end

if length(sigmas)==1
    sigmas=sigmas.*ones(nbfeatrel,1);
end



nbpapp=round(nbapp/2);
nbpval=round(nbval/2);
nbptest=round(nbtest/2);

%initialisation mémoire
X=zeros(nbpapp*2,nbfeattot);
Xte=zeros(nbptest*2,nbfeattot);   
Xval=zeros(nbpval*2,nbfeattot);   



Y=[-1*ones(nbpapp,1);ones(nbpapp,1)];
Yte=[-1*ones(nbptest,1);ones(nbptest,1)];
Yval=[-1*ones(nbpval,1);ones(nbpval,1)];



%
%
sigma1=sqrtm(wishrnd(eye(nbfeatrel),nbfeatrel));
sigma2=sqrtm(wishrnd(eye(nbfeatrel),nbfeatrel));
m1=sign(randn(1,nbfeatrel));
m2=-m1;

X1=ones(nbpapp,1)*m1+randn(nbpapp,nbfeatrel)*sigma1;
X2=ones(nbpapp,1)*m2+randn(nbpapp,nbfeatrel)*sigma2;
X(:,nbfeatrelIndex)=[X1;X2]; %relevant feature index


X(:,feaIreIndex)= randn(2*nbpapp,nbfeattot-nbfeatrel);


X1=ones(nbptest,1)*m1+randn(nbptest,nbfeatrel)*sigma1;
X2=ones(nbptest,1)*m2+randn(nbptest,nbfeatrel)*sigma2;
Xte(:,nbfeatrelIndex)=[X1;X2];
Xte(:,feaIreIndex)= randn(2*nbptest,nbfeattot-nbfeatrel);

X1=ones(nbpval,1)*m1+randn(nbpval,nbfeatrel)*sigma1;
X2=ones(nbpval,1)*m2+randn(nbpval,nbfeatrel)*sigma2;
Xval(:,nbfeatrelIndex)=[X1;X2];
Xval(:,feaIreIndex)= randn(2*nbpval,nbfeattot-nbfeatrel);

