function [X,Y,Xte,Yte,Xval,Yval]=GetMultiTaskFeatures(nbtasks,nbfeatrel,nbfeattot,nbapp,nbtest,sigmas,nbval)
% returns a cell containing several tasks for mutitask learnbing


if nargin < 7
    nbval=0;
end;
%initialisation mémoire
X=cell(nbtasks,1);
Xte=cell(nbtasks,1);
Y=cell(nbtasks,1);
Yte=cell(nbtasks,1);
Xval=cell(nbtasks,1);
Yval=cell(nbtasks,1);

if length(nbfeatrel)==1;
    nbfeatrel=nbfeatrel*ones(nbtasks,1);
end;
if ~iscell(sigmas)
    for i=1:nbtasks
        sigmaaux{i}=sigmas;
    end;
    sigmas=sigmaaux;
end;
 for i=1:nbtasks
    [X{i},Y{i},Xte{i},Yte{i},Xval{i},Yval{i}]=GetFeatureSelectionData(nbfeatrel(i),nbfeattot,nbapp,nbtest,sigmas{i},nbval);
end;


function [X,Y,Xte,Yte,Xval,Yval]=GetFeatureSelectionData(nbfeatrel,nbfeattot,nbapp,nbtest,sigmas,nbval)
% returns datas with nbfeatrel relevant canals and nbfeattot total canals,
% features are centered on -1 or 1 and sigma for each relevant canal can be selected

if nargin < 6
    nbval=0;
end;

if nargin<5
     sigmas=ones(nbfeatrel,1);
end

if length(sigmas)==1
    sigmas=sigmas.*ones(nbfeatrel,1);
end



nbpapp=round(nbapp/2);
nbpval=round(nbval/2);
nbptest=round(nbtest/2);

%initialisation mémoire
X=zeros(nbpapp*2,nbfeattot);
Xte=zeros(nbptest*2,nbfeattot);   
Xval=zeros(nbpval*2,nbfeattot);   



Y=[-1*ones(nbpapp,1);ones(nbpapp,1)];
Yte=[-1*ones(nbptest,1);ones(nbptest,1)];
Yval=[-1*ones(nbpval,1);ones(nbpval,1)];



%
%
sigma1=sqrtm(wishrnd(eye(nbfeatrel),nbfeatrel));
sigma2=sqrtm(wishrnd(eye(nbfeatrel),nbfeatrel));
m1=sign(randn(1,nbfeatrel));
m2=-m1;

X1=ones(nbpapp,1)*m1+randn(nbpapp,nbfeatrel)*sigma1;
X2=ones(nbpapp,1)*m2+randn(nbpapp,nbfeatrel)*sigma2;
X(:,1:nbfeatrel)=[X1;X2];
X(:,nbfeatrel+1:nbfeattot)= randn(2*nbpapp,nbfeattot-nbfeatrel);


X1=ones(nbptest,1)*m1+randn(nbptest,nbfeatrel)*sigma1;
X2=ones(nbptest,1)*m2+randn(nbptest,nbfeatrel)*sigma2;
Xte(:,1:nbfeatrel)=[X1;X2];
Xte(:,nbfeatrel+1:nbfeattot)= randn(2*nbptest,nbfeattot-nbfeatrel);

X1=ones(nbpval,1)*m1+randn(nbpval,nbfeatrel)*sigma1;
X2=ones(nbpval,1)*m2+randn(nbpval,nbfeatrel)*sigma2;
Xval(:,1:nbfeatrel)=[X1;X2];
Xval(:,nbfeatrel+1:nbfeattot)= randn(2*nbpval,nbfeattot-nbfeatrel);

