%
% script for computing BCI results 
% 
%
%
clear all
close all
addpath('..')
addpath('../others');

subjects=[1 2 3 4 6 7 8 9];
nbtasks=length(subjects);
nbtrain=400; % training examples per subject
dim=256;
nbitermax=20;
Ncv=10;
Cvec=logspace(-2,3,Ncv);
doSave=1;


bcifileoption;
filename=['bciepfl-nbtrain' int2str(nbtrain) '-dim' int2str(dim) '-nbiter' int2str(nbitermax)]


%
% ------------------------------------------------------------------------
%%                   Building the kernels parameters
%------------------------------------------------------------------------

kernelt={'poly'  };
kerneloptionvect={ [1] };
variablevec={'single'};



[kernel,kerneloptionvec,variableveccell]=CreateKernelListWithVariable(variablevec,dim,kernelt,kerneloptionvect);
[InfoKernel]=CreateInfoKernel(variablevec,dim,kernel,kerneloptionvec);




load(['CV' int2str(nbtrain)]);
classcode=[1 -1];
for iter=1:nbitermax;
    iter

    %----------------------------------------------------------------------
    %
    %    Comparing different MTL  situations
    %
    %----------------------------------------------------------------------
    for i=1:nbtasks
        load(['S' int2str(subjects(i))]);
        size(x)
        xapp=x(indice{iter,i}.app,:); yapp=y(indice{iter,i}.app);
        xval=x(indice{iter,i}.val,:); yval=y(indice{iter,i}.val);
        xtest=x(indice{iter,i}.test,:); ytest=y(indice{iter,i}.test);
        Y{i}=yapp; Yte{i}=ytest; Yv{i}=yval;
        X{i}=xapp; Xte{i}=xtest; Xv{i}= xval;
        Weights{i}=ones(1,dim);
    end;
    
        options.norm_q=0;
        options.annealing=0;
        options.epsilon=1e-3;
        options.linear=1;
        options.pvec=1; % if == 1 crossval on p
        pvec=[0.5 0.75 0.9];
        [AUCp(iter),ErrEM1,nbvarp(iter),exponpopt(iter),AUCpz(iter)]=bcicomparemtlCV(X,Y,Xv,Yv,Xte,Yte,Cvec,pvec,InfoKernel,Weights,options,verbose);
    
        options.norm_p=1;
        options.annealing=0;
        options.epsilon=1e-3;
        options.linear=1;
        options.pvec=0; % if == 1 crossval on p
        qvec=[0.1 0.2 0.5];

      [AUCq(iter),ErrEM1,nbvarq(iter),exponqopt(iter),AUCqz(iter)]=bcicomparemtlCV(X,Y,Xv,Yv,Xte,Yte,Cvec,qvec,InfoKernel,Weights,options,verbose);

    options.norm_p=1;
    options.norm_q=0;
    options.annealing=0;
    options.epsilon=1e-3;
    options.linear=1;
    [AUCL1L2(iter),ErrEM1,nbvarL1L2(iter),AUCL1L2z(iter)]=bcicomparemtlL1L2CV(X,Y,Xv,Yv,Xte,Yte,Cvec,InfoKernel,Weights,options,verbose);
   
    [aucsingleL1(iter),nbvarsingleL1(iter)]=bcicomparesvmsingleL1(x,y,indice,Cvec,subjects,InfoKernel,iter,options,verbosesvm);

    aucsingle(iter)=bcicomparesvmsingle(x,y,indice,Cvec,subjects,iter,options,verbosesvm);
    aucpooled(iter)=bcicomparesvmpooled(x,y,indice,Cvec,subjects,iter,options,verbosesvm);
    [aucpooledL1(iter),nbvarpooledL1(iter)]=bcicomparesvmpooledL1(x,y,indice,Cvec,subjects,InfoKernel,iter,options,verbosesvm);

    if doSave
        save(filename)
    end;
end;
clear X Y Xv Yv Xte Yte x y xapp yapp xtest ytest xval yval

if doSave
    save(filename)
end;
