

clear all
close all
addpath('..')


r=[2];
N=20;
nbapp=300;
nbval=50;
nbtest=500;
sigmas=1;
nbtasks=4;
C=1000;

%rand('seed',0);
%randn('seed',0);

verbose=1;

%------------------------------------------------------
% choosing the stopping criterion
%------------------------------------------------------
options.stopvariation=1; 
options.seuildiffsigma=1e-4;    

%------------------------------------------------------
% Setting some numerical parameters
%------------------------------------------------------

options.lambdareg = 1e-8;          % ridge added to kernel matrix
options.linear=0;
options.multiclass=0;
%------------------------------------------------------
% some algorithms paramaters
%------------------------------------------------------%
options.nbitermax=100;             % maximal number of iteration
              
options.verbosesvm=0;              % verbosity of inner svm algorithm



%--------------------------------------------------------------------------
% p norm parameter
%--------------------------------------------------------------------------
options.stopvariationlp=1; % use variation of weights for stopping criterion
options.seuildiffsigmalp=1e-2;
options.lpnbitermax = 100;
options.norm_p  = 1;
options.epsilon=0.001;

%
%------------------------------------------------------------------------
%                  Building Kernel and normalizing
%------------------------------------------------------------------------

kernelt={'gaussian'  };
kerneloptionvect={ [0.2] };
variablevec={'single'};
dim=N;
[kernel,kerneloptionvec,variableveccell]=CreateKernelListWithVariable(variablevec,dim,kernelt,kerneloptionvect);
[InfoKernel]=CreateInfoKernel(variablevec,dim,kernel,kerneloptionvec);


[xapp,yapp,xtest,ytest,xtest1,xtest2]=datasets('MultiClassCheckers',nbapp,nbtest,1);
xapp=[xapp randn(size(xapp,1),N-2)]; 
xtest=[xtest randn(size(xtest,1),N-2)]; 
[xapp,xtest]=normalizemeanstd(xapp,xtest);
for k=1:nbtasks
        Y{k}=(yapp==k) - (yapp~=k);
        Yte{k}=(ytest==k) - (ytest~=k)
end;
X{1}=xapp;
Xte{1}=xtest;
K=mtlkernels(X,InfoKernel,options);
[K,Weigths]=mtlNormalizekernels(K);
options.multiclass=1;

%-------------------------------------------------------------------------
%                  EM L1-Lq
%--------------------------------------------------------------------------
options.norm_q=0;
tic
[d,w,bsvm,posw,Norme,storyEM]=mtlmklsvmEM(K,Y,C,options,verbose);
toc
ErrEM0=EvalMultiTaskEMMultiClass(X,Xte,Yte,InfoKernel,Weigths,d,w,bsvm,posw,options);
%-------------------------------------------------------------------------
%                  EM Lp-Lq
%--------------------------------------------------------------------------
options.norm_q=0;
options.norm_p=0.5;
options.annealing=0;
options.epsilon=1e-3;
[d2,w,bsvm,posw,NormeFtaskKernel,betasEM] = lpmklmtlsvmEM(K,Y,C,options,verbose);
ErrEM1=EvalMultiTaskEMMultiClass(X,Xte,Yte,InfoKernel,Weigths,d2./(betasEM.^2),w,bsvm,posw,options);

