function [W,b,weigth] = lpmklmtlsvmProx(X,Y,lambda,options,verbose)


% Usage 
%
% 
% [W,b,weigth] = lpmklmtlsvmProx(X,Y,lambda,options,verbose)
%
%  X : cells of kernel. 1 cell per task
%  Y : cells of outputs 1 cell per task
%  C : regularization parameters
%  options.norm_q : this is actually s in the paper.  
%                   should be equal to zero for l1-ell2
%  options.norm_p : p in the ell_p-ell_q penalty
%
%  options.lpnbitermax : max nb of iteration in the reweighted scheme
%  options.seuildiffsigmalp : stop when the weight's variation in the
%                           reweighted scheme is below this value
%
%
%
% outputs
%
% W : the weights
% b : the biases
% weigth : the beta weights in the paper. You need these weights
% for appropriate evaluation.
%
%
%

nbtasks=length(Y);

%nbkernel=size(K{1},3);
p=options.norm_p ;
q=options.norm_q;
dim=size(X{1},2);
weigth=ones(dim,1);
lambda=lambda*ones(dim,1);


eps=options.epsilon;
MatWeigth=[];
W=zeros(dim,nbtasks);
kk=1;
Wold=W+1;
iter=1;
while iter <= options.lpnbitermax &  norm(abs(W-Wold),'inf')> options.seuildiffsigmalp
    %norm(abs(W-Wold),inf)
    Wold=W;
    [W,b]=mtlmklsvmProxAdapt(X,Y,lambda.*weigth,options,verbose);
    %obj(end) 
    normeK=(sum(abs(W).^q,2).^(1/q)) ;    % shrink
    if p<1
        weigth=1./(abs(normeK)+eps).^(1-p);
        
        iter=iter+1;
    else
        weigth=1./(abs(normeK)+eps).^(1-p);
        iter=options.lpnbitermax;
    end;
    options.Winit=W;

end;
