%function papermtlocr(typelettre,indexwriter,top,comment)

%

clear all
close all
typelettre=['h' 'n'];  %ok
indexwriter=[];
top=20;
comment='';


addpath('../others');



ratio=0.4;
ratiocv=0.5;
nbiter=1;

nbitercv=10; % nb de decoupage
Ncv=10;  % nb de C evalué

doCV=1

%Cvec=logspace(-2,3,Ncv);
Cvec=logspace(-1,3,Ncv);
pvec=[0.75 0.9 0.95 ];
doSave=1;


doL1L2=1;
doLpL2=1;

doPooled=1;   % pooled l1 - needs mkl linear
doPooledSVM=1;
doSep=1;
doSepSVM=1;

Ocrfileoption;
seuil=0.01;
if isempty(indexwriter)
    indexwriter=1:180;
    bool=1;
else
    bool=0;
end;



typelettreaux=typelettre-'a'+1;
[X,y,writer]=OcrExtractLetterofWriter(typelettreaux,indexwriter);
y(y==typelettreaux(1))=1;
y(y==typelettreaux(2))=-1;
dim=128;

[Xa,ya,sizeA,Pos,Neg]=OcrDataperTask(X,y,writer);
ind=find(Pos > 10 & Neg >10);
if bool
    [aux,ind]=sort(sizeA);
    indexwriter=ind(end-top+1:end);
    [X,y,writer]=OcrExtractLetterofWriter(typelettreaux,indexwriter);
    y(y==typelettreaux(1))=1;
    y(y==typelettreaux(2))=-1;
    [Xa,ya,sizeA,Pos,Neg]=OcrDataperTask(X,y,writer);
end;

if doSave
    if nargin <=3, comment='';end;
    filename=['OCR-' (typelettre(1)) '-' (typelettre(2))  '-nbtask' int2str(length(indexwriter))...
        '-' int2str(min(indexwriter)) '-'  int2str(max(indexwriter)) '-nbapp' int2str(ratio*100) '-'...
        comment]
end;




%------------------------------------------------------------------------
%  Building the kernels parameters
%------------------------------------------------------------------------

kernelt={'poly'  };
kerneloptionvect={ [1] };
variablevec={'single'};





[kernel,kerneloptionvec,variableveccell]=CreateKernelListWithVariable(variablevec,dim,kernelt,kerneloptionvect);
[InfoKernel]=CreateInfoKernel(variablevec,dim,kernel,kerneloptionvec);


for i=1:nbiter

    i

    %----------------------------------------------------------------------
    %           Creating dataset
    %----------------------------------------------------------------------

    rand('seed',i);
    randn('seed',i);
    [Xapp,Yapp,Xtest,Ytest]=OcrDivideData(Xa,ya,ratio);
    for t=1:top
        [Xapp{t},Xtest{t}] = normalizemeanstd(Xapp{t},Xtest{t});
    end;


    %----------------------------------------------------------------------
    %           Cross-Validation
    %----------------------------------------------------------------------
    if doCV
        for itercv=1:nbitercv
            rand('seed',i*itercv)
            randn('seed',i*itercv)
            [Xaux,yaux,Xval,Yval]=OcrDivideData(Xapp,Yapp,ratiocv);


            if doL1L2 || doLpL2
                K=mtlkernels(Xaux,InfoKernel,options);
                %         [K,Weigths]=mtlNormalizekernels(K);
                for t=1:top
                    Weigths{t}=ones(1,dim);
                end;
            end;


            %---------------------------------------------------------------------
            %   L1-L2 CrossValidation
            %---------------------------------------------------------------------
            if doL1L2
                options.norm_p=1;
                options.norm_q=0;
                for j=1:length(Cvec)
                    C=Cvec(j);tic
                    [Sigma,Alpsup,w0,pos] = mtlmklsvmEM(K,yaux,C,options,verbose);
                    ErrL1val(j,itercv)=EvalMultiTaskEM(Xaux,Xval,Yval,InfoKernel,Weigths,Sigma,Alpsup,w0,pos,options);
                end;

            end;

            %---------------------------------------------------------------------
            %   Lp-L2 q=0 CrossValidation
            %--------------------------------------------------------------

            if doLpL2

                options.norm_q=0;
                options.annealing=0;
                options.epsilon=1e-3;
                Errval(:,:,itercv)=OcrCompMtlCV(K,yaux,Cvec,pvec,Xaux,Xval,Yval,InfoKernel,Weigths,options,verbose);


            end


            %---------------------------------------------------------------------
            %   Pooled L1 CrossValidation
            %---------------------------------------------------------------------

            if doPooled
                %options.norm_q=qpooled;
                Xaux1=[];
                yaux1=[];
                Xval1=[];
                Yval1=[];
                for t=1:length(yaux)
                    Xaux1=[Xaux1; Xaux{t}];
                    yaux1=[yaux1;yaux{t}];
                    Xval1=[Xval1; Xval{t}];
                    Yval1=[Yval1;Yval{t}];
                end;

                for j=length(Cvec):-1:1
                    C=Cvec(j);
                    tic
                    [Sigma,Alpsup,w0,pos] = mklsvmlinear(Xaux1,yaux1,C,mkloptions,verbose);
                    ypred=mklsvmlinearval(Xval1,Xaux1(pos,:),Alpsup,w0,Sigma);
                    ErrPooledval(j,itercv)=mean(sign(ypred)~=Yval1);
                    %     mkloptions.sigmainit=Sigma;
                    alphainit=zeros(size(yaux1));alphainit(pos)=abs(Alpsup);
                    %  mkloptions.alphainit=alphainit;

                end;
                %      mkloptions=rmfield(mkloptions,'alphainit');
                %      mkloptions=rmfield(mkloptions,'sigmainit');
                clear Xaux1 Xval1
            end;

            %---------------------------------------------------------------------
            %   Pooled SVM CrossValidation
            %---------------------------------------------------------------------

            if doPooledSVM
                %options.norm_q=qpooled;
                Xaux1=[];
                yaux1=[];
                Xval1=[];
                Yval1=[];
                for t=1:length(yaux)
                    Xaux1=[Xaux1; Xaux{t}];
                    yaux1=[yaux1;yaux{t}];
                    Xval1=[Xval1; Xval{t}];
                    Yval1=[Yval1;Yval{t}];
                end;
                kerneloption= 1;
                kernel='poly';
                span=1;
                tic

                for j=1:length(Cvec)
                    C=Cvec(j);
                    [xsup,w,b,pos]=svmclass(Xaux1,yaux1,C,options.lambdareg,kernel,kerneloption,0);
                    [ypredv]=svmval(Xval1,xsup,w,b,kernel,kerneloption,span);
                    ErrPooledSVMval(j,itercv)=mean(sign(ypredv)~=Yval1);
                end;

                clear Xaux1 Xval1
            end;
            %---------------------------------------------------------------------
            %   Separated L1 CrossValidation
            %---------------------------------------------------------------------

            if doSep
                ErrAux=0;
                SigmaSep=[];

                for t=1:length(ya) %
                    Xaux1=[ Xaux{t}];
                    yaux1=[yaux{t}];
                    Xval1=[ Xval{t}];
                    Yval1=[Yval{t}];
                    for j=length(Cvec):-1:1
                        C=Cvec(j);
                        [Sigma,Alpsup,w0,pos] = mklsvmlinear(Xaux1,yaux1,C,mkloptions,verbose);
                        ypred=mklsvmlinearval(Xval1,Xaux1(pos,:),Alpsup,w0,Sigma);
                        ErrSepVal(t,j,itercv)=mean(sign(ypred)~=Yval1);

                    end;
                end;
            end;

            %---------------------------------------------------------------------
            %   Separated SVM CrossValidation
            %---------------------------------------------------------------------
            if doSepSVM

                Xaux1=[];
                yaux1=[];
                Xval1=[];
                Yval1=[];
                for t=1:length(yaux)
                    Xaux1=[Xaux{t}];
                    yaux1=[yaux{t}];
                    Xval1=[ Xval{t}];
                    Yval1=[Yval{t}];

                    kerneloption= 1;
                    kernel='poly';
                    span=1;
                    tic

                    for j=1:length(Cvec)
                        C=Cvec(j);
                        [xsup,w,b,pos]=svmclass(Xaux1,yaux1,C,options.lambdareg,kernel,kerneloption,0);
                        [ypredv]=svmval(Xval1,xsup,w,b,kernel,kerneloption,span);
                        ErrSepSVMval(t,j,itercv)=mean(sign(ypredv)~=Yval1);
                    end;
                end;
                clear Xaux1 Xval1
            end;

        end;
    end;
%     %----------------------------------------------------------------------
%     %
%     %
%     %           Learning
%     %
%     %
%     %----------------------------------------------------------------------
%     if doL1L2 || doLpL2
%         K=mtlkernels(Xapp,InfoKernel,options);
%         %     [K,Weigths]=mtlNormalizekernels(K);
%     end
% 
%     %----------------------------------------------------------------------
%     %           L1L2   Learning
%     %----------------------------------------------------------------------
% 
%     if doL1L2
%         options.norm_p=1;
%         options.norm_q=0;
% 
%         if doCV
%             meanErrL1val=mean(ErrL1val');
%             [mini,indC]=min(meanErrL1val);
%             %              ind=find(meanErrL1val==mini);
%             %             if length(ind)>1
%             %                 indC=max(ind);
%             %             end;
%         else
% 
%             indC=Ncv
%         end;
%         tic
%         [SigmaL1,Alpsup,w0,pos] = mtlmklsvmEM(K,Yapp,Cvec(indC),options,verbose);
%         timeL1(i)=toc;
% 
%         ErrL1(i)=EvalMultiTaskEM(Xapp,Xtest,Ytest,InfoKernel,Weigths,SigmaL1,Alpsup,w0,pos,options);
%         SparsL1(i)=sum(sum(SigmaL1)>seuil);
%         SigmaL1Mat{i}=SigmaL1;
%     end;
% 
% 
%     %---------------------------------------------------------------------
%     %   Lp-L2 + Learning
%     %---------------------------------------------------------------------
%     if doLpL2
%         options.norm_q=0.0;
%         options.annealing=0;
%         options.epsilon=1e-3;
%         if doCV
%             meanErrval=mean(Errval,3);
%             [mini,indp]=min(min(meanErrval));
%             [auxlig,auxcol]=find(meanErrval==mini);
%             [indp,indaux]=max(auxcol);
%             indC=auxlig(indaux);
%             Psel(i)=pvec(indp);
%             options.norm_p=pvec(indp);
%             %          [mini,indC]=min(min(meanErrval'));
%             %             ind=find(meanErrval(:,indp)==mini);
%             %             if length(ind)>1
%             %                 indC=max(ind);
%             %             end;
% 
%         else
%             options.norm_p=0.5;
%             indC=4
%         end;
%         tic
%         [Sigma,Alpsup,w0,pos,Norme,betasEM] = lpmklmtlsvmEM(K,Yapp,Cvec(indC),options,verbose);
%         time(i)=toc;
%         Spars(i)=sum(sum(Sigma)>seuil);
%         Err(i)=EvalMultiTaskEM(Xapp,Xtest,Ytest,InfoKernel,Weigths,Sigma./(betasEM.^2),Alpsup,w0,pos,options);
%         SigmaLpL2Mat{i}=Sigma;
%     end;
%     %---------------------------------------------------------------------
%     %   Pooled L1 Learning
%     %---------------------------------------------------------------------
%     if doPooled
% 
%         Xaux1=[];
%         yaux1=[];
%         Xtest1=[];
%         Ytest1=[];
%         for t=1:length(ya)
%             Xaux1=[Xaux1; Xapp{t}];
%             yaux1=[yaux1;Yapp{t}];
%             Xtest1=[Xtest1; Xtest{t}];
%             Ytest1=[Ytest1;Ytest{t}];
%         end;
% 
%         if doCV
%             [mini,indC]=min(mean(ErrPooledval,2));
%         else
%             indC=3
%         end;
%         [Sigma,Alpsup,w0,pos] = mklsvmlinear(Xaux1,yaux1,Cvec(indC),mkloptions,verbose);
%         SparsPooled(i)=sum(Sigma>seuil);
%         ypred=mklsvmlinearval(Xtest1,Xaux1(pos,:),Alpsup,w0,Sigma);
%         ErrPooled(i)=mean(sign(ypred)~=Ytest1);
%         SigmaPooledMat{i}=Sigma;
%     end;
%     %---------------------------------------------------------------------
%     %   Pooled SVM
%     %---------------------------------------------------------------------
%     if doPooledSVM
% 
%         Xaux1=[];
%         yaux1=[];
%         Xtest1=[];
%         Ytest1=[];
%         for t=1:length(ya)
%             Xaux1=[Xaux1; Xapp{t}];
%             yaux1=[yaux1;Yapp{t}];
%             Xtest1=[Xtest1; Xtest{t}];
%             Ytest1=[Ytest1;Ytest{t}];
%         end;
% 
%         if doCV
%             [mini,indC]=min(mean(ErrPooledSVMval,2));
%         else
%             indC=3
%         end;
%         C=Cvec(indC);
%         [xsup,w,b,pos]=svmclass(Xaux1,yaux1,C,options.lambdareg,kernel,kerneloption,0);
%         [ypred]=svmval(Xtest1,xsup,w,b,kernel,kerneloption,span);
%         ErrPooledSVM(i)=mean(sign(ypred)~=Ytest1);
% 
%     end;
%     %---------------------------------------------------------------------
%     %   Separate L1
%     %---------------------------------------------------------------------
%     if doSep
%         ErrAux=0;
%         SigmaSepAux=[];
%         yaux=[];
%         yd=[];
%         for t=1:length(ya) %
%             Xaux1=[ Xapp{t}];
%             yaux1=[Yapp{t}];
%             Xtest1=[ Xtest{t}];
%             Ytest1=[Ytest{t}];
%             yaux=[yaux;Ytest{t}];
%             [mini,indC]=min(mean(ErrSepVal(t,:,:),3));
%             [Sigma,Alpsup,w0,pos] = mklsvmlinear(Xaux1,yaux1,Cvec(indC),mkloptions,verbose);
% 
%             ypred=mklsvmlinearval(Xtest1,Xaux1(pos,:),Alpsup,w0,Sigma);
%             yd=[yd;ypred];
%             ErrAux=ErrAux+1/length(ya)*mean(sign(ypred)~=Ytest1);
%             SigmaSepAux=[SigmaSepAux;Sigma];
%         end;
%         ErrSep(i)=ErrAux;
%         SparsSepSVM(i)=sum( sum(SigmaSepAux>seuil) > 0);
%         SigmaSep{i}={SigmaSepAux};
%     end;
%     %---------------------------------------------------------------------
%     %   Separated SVM
%     %---------------------------------------------------------------------
%     if doSepSVM
%         ErrAux=0;
%         yaux=[];
%         yd=[];
%         for t=1:length(ya) %
%             Xaux1=[ Xapp{t}];
%             yaux1=[Yapp{t}];
%             Xtest1=[ Xtest{t}];
%             Ytest1=[Ytest{t}];
%             yaux=[yaux;Ytest{t}];
%             [mini,indC]=min(mean(ErrSepSVMval(t,:,:),3));
% 
%             [xsup,w,b,pos]=svmclass(Xaux1,yaux1,Cvec(indC),options.lambdareg,kernel,kerneloption,0);
%             [ypred]=svmval(Xtest1,xsup,w,b,kernel,kerneloption,span);
%             yd=[yd;ypred];
%             ErrAux=ErrAux+1/length(ya)*mean(sign(ypred)~=Ytest1);
% 
%         end;
%         ErrSepSVM(i)=ErrAux;
%         %ErrSepSVM(i)=mean(sign(yd)~=yaux);
%     end;


    if doSave
        save(filename)
    end;
end;

clear  X y Xa ya Xapp Yapp Xaux1 yaux1 Xtest Xval Y Ytest Yval
save(filename)

