

clear all
close all
typelettre=['g' 'y'];  %ok
indexwriter=[];
top=5;
comment='Best';


addpath('../others');



ratio=0.9;
ratiocv=0.5;
nbiter=1;

nbitercv=10; % nb de decoupage
Ncv=10;  % nb de C evalué



Cvec=logspace(-2,3,Ncv);
pvec=[0.5 0.75 0.9 0.97];
doSave=0;


doL1L2=1;
doLpL2=0;

doPooled=0;   % pooled l1 - needs mkl linear in SimpleMKL
doPooledSVM=1;
doSep=0;
doSepSVM=1;

Ocrfileoption;
seuil=0.01;
if isempty(indexwriter)
    indexwriter=1:180;
    bool=1;
else
    bool=0;
end;



typelettreaux=typelettre-'a'+1;
[X,y,writer]=OcrExtractLetterofWriter(typelettreaux,indexwriter);
y(y==typelettreaux(1))=1;
y(y==typelettreaux(2))=-1;
dim=128;
[Xa,ya,sizeA,Pos,Neg]=OcrDataperTask(X,y,writer);
ind=find(Pos > 10 & Neg >10);
if bool
    [aux,ind]=sort(sizeA);
    indexwriter=ind(end-top+1:end);
    [X,y,writer]=OcrExtractLetterofWriter(typelettreaux,indexwriter);
    y(y==typelettreaux(1))=1;
    y(y==typelettreaux(2))=-1;
    [Xa,ya,sizeA,Pos,Neg]=OcrDataperTask(X,y,writer);
end;

if doSave
    if nargin <=3, comment='';end;
    filename=['OCR-' (typelettre(1)) '-' (typelettre(2))  '-nbtask' int2str(length(indexwriter))...
        '-' int2str(min(indexwriter)) '-'  int2str(max(indexwriter)) '-nbapp' int2str(ratio*100) '-'...
        comment]
end;




%------------------------------------------------------------------------
%  Building the kernels parameters
%------------------------------------------------------------------------

kernelt={'poly'  };
kerneloptionvect={ [1] };
variablevec={'single'};





[kernel,kerneloptionvec,variableveccell]=CreateKernelListWithVariable(variablevec,dim,kernelt,kerneloptionvect);
[InfoKernel]=CreateInfoKernel(variablevec,dim,kernel,kerneloptionvec);






%----------------------------------------------------------------------
%           Creating dataset
%----------------------------------------------------------------------
i=1;
rand('seed',i);
randn('seed',i);
[Xapp,Yapp,Xtest,Ytest]=OcrDivideData(Xa,ya,ratio);
for t=1:top
    [Xapp{t},Xtest{t}] = normalizemeanstd(Xapp{t},Xtest{t});
end;

tic
for itercv=1:nbitercv
    rand('seed',i*itercv)
    randn('seed',i*itercv)
    [Xaux,yaux,Xval,Yval]=OcrDivideData(Xapp,Yapp,ratiocv);


    if doL1L2 || doLpL2
        K=mtlkernels(Xaux,InfoKernel,options);
        %[K,Weigths]=mtlNormalizekernels(K);
        for t=1:top
            Weigths{t}=ones(1,dim);
        end;
    end;


    %---------------------------------------------------------------------
    %   L1-L2 CrossValidation EM and Proximal algorithm
    %---------------------------------------------------------------------
    if doL1L2
        options.linear=1;
        options.norm_p=1;
        options.norm_q=0; % compris entre 0 et 1
        options.verbosesvm=0;
        for j=1:length(Cvec)
            C=Cvec(j);tic
            [SigmaL1{j},Alpsup,w0,pos] = mtlmklsvmEM(Xaux,yaux,C,options,verbose);
            Erraux(j)=EvalMultiTaskEM(Xaux,Xval,Yval,InfoKernel,Weigths,SigmaL1{j},Alpsup,w0,pos,options);
        end;
        [mini,indC]=min(Erraux);
        ErrL1(itercv)=mini;
        SparsL1(itercv)=sum(sum(SigmaL1{indC})>seuil);

        options.norm_q=2;
     
        lambdavec=[1:2:30];
        ErrProxa=zeros(size(lambdavec));
        for j=1:length(lambdavec)
            lambda=lambdavec(j);
            W=mtlmklsvmProx(Xaux,yaux,lambda,options,verbose);
            for t=1:top
                ErrProxa(j)=ErrProxa(j)+ 1/top*mean(sign(Xval{t}*W(:,t))~=Yval{t});
            end;
            [mini,indC]=min(ErrProxa);
            ErrProx(itercv)=mini;
        end;
    end;

    %---------------------------------------------------------------------
    %   Lp-L2 q=0 CrossValidation
    %--------------------------------------------------------------

    if doLpL2
        options.linear=0;
        options.norm_q=0.9;
        options.annealing=0;
        options.epsilon=1e-1;
        [ErrauxLp,SigmaLp]=OcrCompMtlCV(K,yaux,Cvec,pvec,Xaux,Xval,Yval,InfoKernel,Weigths,options,verbose);
        [mini,indC]=min(min(ErrauxLp'));
        [mini,indp]=min(min(ErrauxLp));
        Err(itercv)=mini;
        Spars(itercv)=sum(sum(SigmaLp{indC,indp})>seuil);
    end


    %---------------------------------------------------------------------
    %   Pooled L1 CrossValidation
    %---------------------------------------------------------------------

    if doPooled
        %options.norm_q=qpooled;
        Xaux1=[];
        yaux1=[];
        Xval1=[];
        Yval1=[];
        for t=1:length(yaux)
            Xaux1=[Xaux1; Xaux{t}];
            yaux1=[yaux1;yaux{t}];
            Xval1=[Xval1; Xval{t}];
            Yval1=[Yval1;Yval{t}];
        end;

        for j=length(Cvec):-1:1
            C=Cvec(j);
            tic
            [SigmaPooled(j,:),Alpsup,w0,pos] = mklsvmlinear(Xaux1,yaux1,C,mkloptions,verbose);
            ypred=mklsvmlinearval(Xval1,Xaux1(pos,:),Alpsup,w0,SigmaPooled(j,:));
            ErrauxPL1(j)=mean(sign(ypred)~=Yval1);
            alphainit=zeros(size(yaux1));alphainit(pos)=abs(Alpsup);

        end;
        [mini,indC]=min(ErrauxPL1);
        SparsPooled(itercv)=sum(SigmaPooled(indC,:)>seuil);
        ErrPooled(itercv)=mini;

        clear Xaux1 Xval1
    end;

    %---------------------------------------------------------------------
    %   Pooled SVM CrossValidation
    %---------------------------------------------------------------------

    if doPooledSVM
        %options.norm_q=qpooled;
        Xaux1=[];
        yaux1=[];
        Xval1=[];
        Yval1=[];
        for t=1:length(yaux)
            Xaux1=[Xaux1; Xaux{t}];
            yaux1=[yaux1;yaux{t}];
            Xval1=[Xval1; Xval{t}];
            Yval1=[Yval1;Yval{t}];
        end;
        kerneloption= 1;
        kernel='poly';
        span=1;
        tic

        for j=1:length(Cvec)
            C=Cvec(j);
            [xsup,w,b,pos]=svmclass(Xaux1,yaux1,C,options.lambdareg,kernel,kerneloption,0);
            [ypredv]=svmval(Xval1,xsup,w,b,kernel,kerneloption,span);
            ErrauxPS(j)=mean(sign(ypredv)~=Yval1);
        end;
        ErrPooledSVM(itercv)=min(ErrauxPS);
        clear Xaux1 Xval1
    end;
    %---------------------------------------------------------------------
    %   Separated L1 CrossValidation
    %---------------------------------------------------------------------

    if doSep
        ErrAux=0;

        for j=length(Cvec):-1:1
            SigmaSepAux=[];
            for t=1:length(ya) %
                Xaux1=[ Xaux{t}];
                Yaux1=[yaux{t}];
                Xval1=[ Xval{t}];
                Yval1=[Yval{t}];


                C=Cvec(j);
                [Sigma,Alpsup,w0,pos] = mklsvmlinear(Xaux1,Yaux1,C,mkloptions,verbose);
                ypred=mklsvmlinearval(Xval1,Xaux1(pos,:),Alpsup,w0,Sigma);
                ErrauxSep(t,j) =mean(sign(ypred)~=Yval1);
                SigmaSepAux=[SigmaSepAux;Sigma];



            end;
            SparsSepSVMA(j)=sum( sum(SigmaSepAux>seuil) > 0);
        end;

        [mini,indC]=min(mean(ErrauxSep));
        ErrSep(itercv) = mini;
        SparsSepSVM(itercv)=SparsSepSVMA(indC);
    end;

    %---------------------------------------------------------------------
    %   Separated SVM CrossValidation
    %---------------------------------------------------------------------
    if doSepSVM

        Xaux1=[];
        yaux1=[];
        Xval1=[];
        Yval1=[];
        for t=1:length(yaux)
            Xaux1=[Xaux{t}];
            yaux1=[yaux{t}];
            Xval1=[ Xval{t}];
            Yval1=[Yval{t}];

            kerneloption= 1;
            kernel='poly';
            span=1;
            tic

            for j=1:length(Cvec)
                C=Cvec(j);
                [xsup,w,b,pos]=svmclass(Xaux1,yaux1,C,options.lambdareg,kernel,kerneloption,0);
                [ypredv]=svmval(Xval1,xsup,w,b,kernel,kerneloption,span);
                ErrauxSepSVM(t,j)=mean(sign(ypredv)~=Yval1);
            end;
        end;
        ErrSepSVM(itercv)=min(mean(ErrauxSepSVM));

        clear Xaux1 Xval1
    end;
    if doSave
        save(filename)
    end;

end;

fprintf('--------Average test error-------------------\n')
fprintf('L1L2 SVM : \t\t %2.3f\n',mean(ErrL1));
fprintf('L1L2 Proximal : \t %2.3f\n',mean(ErrProx));
fprintf('Pooled ell_1 SVM : \t %2.3f\n',mean(ErrPooled));
fprintf('Pooled SVM : \t\t %2.3f\n',mean(ErrPooledSVM));
fprintf('Separated ell_1 SVM : \t %2.3f\n',mean(ErrSep));
fprintf('Separated SVM : \t %2.3f\n',mean(ErrSepSVM));



clear  X y Xa ya Xapp Yapp Xaux1 yaux1 Xtest Xval Y Ytest Yval
save(filename)

