function ICML_toy(r,N,nbapp,nbval,nbtest,sigmas,nbtasks,Cvec,lambdavec,pvec,nbiter)

% %%%calcs for ICML
% clear all
% close all
% 
% 
% 
% %Data Generation

% r=4;
% N=100;
% nbapp=50;
% nbval=50;
% nbtest=1000;
% sigmas=1;
% nbtasks=4;
% NbCvec=10;
% nbiter=10;
% lambdavec=logspace(0.1,2,20);
% Cvec=logspace(-2,2,NbCvec);
% pvec=[0.5 0.75 0.9];

%%%------------------------------------------------------------------------
comment='Prox';
q=2
Toyfileoption;
smallreg=0.001;
doL1Lq=1;
doL1LqEM=1;
doLpLq=1;
doLpLqEM=1;
doPooledSep=1;
doSave=1;

seuil=1e-5;
if doSave

    filename=['Toy' comment  '-rel' int2str(r) '-dim' int2str(N) '-nbtask' int2str(nbtasks)...
        '-nbapp' int2str(nbapp) '-nbiter' int2str(nbiter)  ]

end;
rand('state',0);
randn('state',0);



kernelt={'poly'  };
kerneloptionvect={ [1 ] };
variablevec={'single'};
dim=N;

[kernel,kerneloptionvec,variableveccell]=CreateKernelListWithVariable(variablevec,dim,kernelt,kerneloptionvect);
[InfoKernel]=CreateInfoKernel(variablevec,dim,kernel,kerneloptionvec);


for i=1:nbiter
    i
    rand('state',i);
    randn('state',i);

    %----------------------------------------------------------------------
    %           Creating dataset
    %----------------------------------------------------------------------
    [X,Y,Xte,Yte,Xval,Yval]=GetMultiTaskFeatures(nbtasks,r,N,nbapp,nbtest,sigmas,nbval);
    [X,Y,Xval,Yval,Xte,Yte]=GetMultiTaskFeatures(nbtasks,r,N,nbapp,nbtest,sigmas,nbval);
    for k=1:nbtasks
        [Xa{k},Xval{k},meanxapp{k},stdxapp{k}] = normalizemeanstd(X{k},Xval{k});
        [X{k},Xte{k}] = normalizemeanstd(X{k},Xte{k});
        Weigths{k}=ones(N,1);
    end;


    %---------------------------------------------------------------------
    %   L1-Lq Prox
    %---------------------------------------------------------------------
    if doL1Lq
        options.norm_q=q;
        for j=1:length(lambdavec)
            lambda=lambdavec(j);
            [W,b]=mtlmklsvmProxAdapt(X,Y,lambda,options,verbose);
            ErrL1val(j)=EvalMultiTaskProx(Xval,Yval,W,b);
            ErrL1A(j)=EvalMultiTaskProx(Xte,Yte,W,b);
        end;

        [mini,ind]=min(ErrL1val);
        tic
        [W,b]=mtlmklsvmProxAdapt(X,Y,lambdavec(ind),options,verbose);
        timeL1(i)=toc;
        ErrL1(i)=EvalMultiTaskProx(Xte,Yte,W,b);
        SparsL1(i)=sum(sum(abs(W),2)>seuil);
        [precL1(i),recL1(i),FmeasL1(i)]=evaluateSparsity(sum(abs(W),2),1:r,seuil);
        SigmaL1Mat{i}=W;
        ErrL1B(i)=min(ErrL1A);
    end;
    %---------------------------------------------------------------------
    %   L1-Lq EM
    %---------------------------------------------------------------------
    if doL1LqEM
        options.norm_q=(2-q)/q;
        options.linear=1;
        for j=1:length(Cvec)
            C=Cvec(j);tic
            [Sigma,Alpsup,w0,pos] = mtlmklsvmEM(X,Y,C,options,verbose);
            ErrL1valA(j)=EvalMultiTaskEM(X,Xval,Yval,InfoKernel,Weigths,Sigma,Alpsup,w0,pos,options);
            ErrL1EMA(j)=EvalMultiTaskEM(X,Xte,Yte,InfoKernel,Weigths,Sigma,Alpsup,w0,pos,options);
        end;
        [mini,ind]=min(ErrL1valA);
        tic
        [SigmaL1,Alpsup,w0,pos] = mtlmklsvmEM(X,Y,Cvec(ind),options,verbose);
        timeL1(i)=toc;
        ErrL1EM(i)=EvalMultiTaskEM(X,Xte,Yte,InfoKernel,Weigths,SigmaL1,Alpsup,w0,pos,options);
        [precL1EM(i),recL1EM(i),FmeasL1EM(i)]=evaluateSparsity(sum(SigmaL1),1:r,seuil);
        SparsL1EM(i)=sum(sum(Sigma)>seuil);
        SigmaL1MatEM{i}=SigmaL1;
        ErrL1EMB(i)=min(ErrL1EMA);
        
        ind=find(sum(Sigma)<(max(sum(Sigma))*0.01));
        SigmaA=Sigma;
        SigmaA(:,ind)=0;
        [precL1EMAdapt(i),recL1EMAdapt(i),FmeasL1EMAdapt(i)]=evaluateSparsity(sum(SigmaA),1:r,seuil);
        %
    end
    %---------------------------------------------------------------------
    %   Lp-Lq Prox
    %---------------------------------------------------------------------
    if doLpLq
        Errval=[];
        options.norm_q=q;
        for iterp=length(pvec):-1:1
            options.norm_p=pvec(iterp);
            for j=1:length(lambdavec)
                lambda=lambdavec(j);
                [Wa,ba]=lpmklmtlsvmProx(X,Y,lambda,options,verbose);
                Errval(j,iterp)=EvalMultiTaskProx(Xval,Yval,Wa,ba);
                ErrA(j,iterp)=EvalMultiTaskProx(Xte,Yte,Wa,ba);
            end;

        end;

        [mini,indp]=min(min(Errval));
        Psel(i)=pvec(indp);
        [mini,indC]=min(min(Errval'));
        options.norm_p=pvec(indp);
        tic
        [W,b]=lpmklmtlsvmProx(X,Y,lambdavec(indC),options,verbose);
        Spars(i)=sum(sum(abs(W),2)>seuil);
        [prec(i),rec(i),Fmeas(i)]=evaluateSparsity(sum(abs(W),2),1:r,seuil);
        SigmaMat{i}=W;
        Err(i)=EvalMultiTaskProx(Xte,Yte,W,b);
        ErrB(i)=min(min(ErrA));
    end;

    %---------------------------------------------------------------------
    %   Lp-Lq EM
    %---------------------------------------------------------------------
    if doLpLqEM
        Errval=[];
        options.norm_q=(2-q)/q;
        options.linear=1;
        options.annealing=0;
        options.epsilon=1e-3;
        for iterp=length(pvec):-1:1
            options.norm_p=pvec(iterp);

            if iterp<length(pvec)
                options=rmfield(options,'betainit');
                options=rmfield(options,'alphainit');
                options=rmfield(options,'sigmainit');
            end

            for j=length(Cvec):-1:1
                C=Cvec(j);
                [Sigma,Alpsup,w0,pos,Norme,betasEM] = lpmklmtlsvmEM(X,Y,C,options,verbose);
                options.betainit=betasEM;
                options.sigmainit=Sigma + smallreg;
                options.alphainit=mtlgetalphainits(X,Alpsup,pos);
                Errval(j,iterp)=EvalMultiTaskEM(X,Xval,Yval,InfoKernel,Weigths,Sigma./(betasEM.^2),Alpsup,w0,pos,options);
                ErrvalA(j,iterp)=EvalMultiTaskEM(X,Xte,Yte,InfoKernel,Weigths,Sigma./(betasEM.^2),Alpsup,w0,pos,options);
            end;

        end;
        options=rmfield(options,'betainit');
        options=rmfield(options,'alphainit');
        options=rmfield(options,'sigmainit');
        [mini,indp]=min(min(Errval));
        Psel(i)=pvec(indp);
        [mini,indC]=min(min(Errval'));
        options.norm_p=pvec(indp);
        tic
        [Sigma,Alpsup,w0,pos,Norme,betasEM] = lpmklmtlsvmEM(X,Y,Cvec(indC),options,verbose);
        time(i)=toc;
        SparsEM(i)=sum(sum(Sigma)>seuil);
        [precEM(i),recEM(i),FmeasEM(i)]=evaluateSparsity(sum(Sigma),1:r,seuil);
        ErrEM(i)=EvalMultiTaskEM(X,Xte,Yte,InfoKernel,Weigths,Sigma./(betasEM.^2),Alpsup,w0,pos,options);
        ErrEMB(i)=min(min(ErrvalA));
        SigmaMatEM{i}=Sigma;
        
        ind=find(sum(Sigma)<(max(sum(Sigma))*0.01));
        SigmaA=Sigma;
        SigmaA(:,ind)=0;
        [precEMAdapt(i),recEMAdapt(i),FmeasEMAdapt(i)]=evaluateSparsity(sum(SigmaA),1:r,seuil);
      
    end;
    %--------------------------------------------------------------------------------------
    %  pooledL1  & SeparatedL1 CrossValidation + Learning
    %---------------------------------------------------------------------------------------
    if doPooledSep
        verbosesvm=1;
        [ErrPooledL1,nbvar,Dpooled{i}]=ToypooledL1SVM(X,Y,Xval,Yval,Xte,Yte,Cvec,InfoKernel,options,verbosesvm);
        [ErrSeparatedL1(i),nbvar,Dsep{i}]=ToySeparatedL1SVM(X,Y,Xval,Yval,Xte,Yte,Cvec,InfoKernel,options,verbosesvm);
    end;
    if doSave
        save(filename)
    end;
end;
clear K X Xte Xval Y Yte Yval
save(filename)

