function ToylauncherProx(i)


% This script launches all the computation needed for reproducing 
% the toy problem figures

%clear all
%close all
%i=1

addpath('..')

%
%  comparing the performance of the lp-l2 and the l1-l2 on 
%  some toy problem
%
%



%% Data Generation

r=4 ;
N=100;
nbapp=100;
nbval=100;
nbtest=5000;
sigmas=1;
nbtasks=4;
NbCvec=10;
nbiter=20;
lambdavec=logspace(0.5,1.8,NbCvec);
Cvec=logspace(-2,2,NbCvec);
pvec=[0.2 0.5 0.75 0.9 ];

switch i

    case 1

        % varying the number of relevant variables
        vec=[4 6 8 10 12 16  20];
        for i=1:length(vec)
            r=vec(i);
            ToyCompMtlProx(r,N,nbapp,nbval,nbtest,sigmas,nbtasks,Cvec,lambdavec,pvec,nbiter);
        end;

    case 2

        % varying the number of training examples
        r=4; nbtasks=4; N=100;
        vec=[25:25:75];
        for i=1:length(vec)
            nbapp=vec(i);
            nbval=nbapp;
            ToyCompMtlProx(r,N,nbapp,nbval,nbtest,sigmas,nbtasks,Cvec,lambdavec,pvec,nbiter);
        end;

    case 3

        % varying problem dimensionality
        r=4; nbtasks=4;
        vec=[25:25:75];
        for i=1:length(vec)
            N=vec(i);
            ToyCompMtlProx(r,N,nbapp,nbval,nbtest,sigmas,nbtasks,Cvec,lambdavec,pvec,nbiter);
        end;

    case 4

        % varying number of tasks
        r=4 ;
        N=100;
        nbapp=100;
        nbval=100;
        vec=[1 2 6:2:10];
        for i=1:length(vec)
            nbtasks=vec(i);
            ToyCompMtlProx(r,N,nbapp,nbval,nbtest,sigmas,nbtasks,Cvec,lambdavec,pvec,nbiter);
        end;

end


