%% A demo for running FelMuG algorithm for vector data
function demo_FelMuG_vector

InstallFelMug %adding the classpath


normalizeTrainTest=1;

rng(1); % set the seed for random number generator

%% Generate Multi-task Data
m=30; %number of features
nbapp=100; %number sample per task
nbval=100;
nbtest=5000; %number of testing 
sigmas=1;
nbtasks=4; 
T=nbtasks;
r=5; % common features


tS=floor(r/2);
Kt = tS * ones(T,1);  % task specific features
aK=4;%floor(r/2);
Ka=aK * ones(T,1); % task auxiliary features

[X,Y,Xval,Yval,Xte,Yte,setting]=GetMultiTaskFeaturesTspSyn(nbtasks,r,m,nbapp,nbtest,sigmas,nbval,Kt,Ka);%GetMultiTaskFeaturesTsp(gopt);
comIndex=setting.comIndex;
taskIndex=setting.taskIndex;
auxIndex=setting.auxIndex;



if normalizeTrainTest==1
    for k=1:T
        [X{k},Xte{k}] = normalizemeanstd(X{k},Xte{k});
    end;
end

%% Evluate Multi-task Learning by FelMuG algorithm
opt.maxInt = 25; %maximum number of iterations
opt.K=2; %Least Number of Common Features for Multi-task learning
opt.epslog=10*1e-3; %stopping condition for outer iterations
opt.C=.1; %K=0.5 %.1 for Graph classification
opt.normalizeKernels = 0;
opt.debug_msg=0;
opt.equalmu=0; 

tS=1; 
Kt = tS * ones(T,1); 
opt.Kt=Kt;
tA=1; 
Ka=tA * ones(T,1);
opt.Ka=Ka;

[model]=FelMuG_vector(X,Y,opt);
ErrL1L2=EvalMultiTask_d(X,Xte,Yte,model);
precision=zeros(T,1);
recall=zeros(T,1);
fmea=zeros(T,1);
m=size(X{1},2);    
WF=zeros(T,m);%binary matrix, 0 for unselected, 1 for selected
   
for t=1:T
    w=model.mu(t,:)*model.AllWC{t};
    WF(t,:)=(abs(w)>1e-5)';


    R = sort([comIndex, taskIndex{t}, auxIndex{t}]);

    [precision(t),recall(t),fmea(t)]=evaluateSparsity(w,R,1e-6);
    disp(['Recover Result on task ',num2str(t),' :',num2str(nnz(abs(w)>1e-5)),', Recall:',num2str(recall(t)),'  F1:',num2str(fmea(t))]);

end 
    

disp('=====================================')
disp(['Classification Accuracy:',num2str(1-ErrL1L2)])
disp('=====================================')

% disp(['Average AUC:',num2str(mean(AUC)),' +/- ',num2str(std(AUC))])
disp([' Feature Recover Ave Recall:',num2str(mean(recall)),' +/- ',num2str(std(recall))])
disp([' Feature Recover Ave F-measure:',num2str(mean(fmea)),' +/- ',num2str(std(fmea))])


end