function [fmeasureI,bcI]=evalmklbioinfo(klist,beta,w,w0,nbsv,ytest,indicetest,indicesup,classcode,nopredfrac,options)

nbtest=length(ytest);
efficientrepresentation=0;
nbclass=length(classcode);
Kt=buildKernel(klist,efficientrepresentation,indicetest,indicesup,beta);

kernel='numerical';
kerneloption.matrix=Kt;
switch options.algo
    case 'oneagainstall'
        [ypred,maxi,res] = svmmultival([],[],w,w0,nbsv,kernel,kerneloption);
        ypred=ypred';
    case 'oneagainstone'
        [ypred,maxi] = svmmultivaloneagainstone([],[],w,w0,nbsv,kernel,kerneloption);
        res=maxi;
end;
%[ypred,maxi,res] = svmmultival([],[],w,w0,nbsv,kernel,kerneloption);

expOut = exp( res );
P = expOut ./ repmat( sum(expOut,2), 1, nbclass );
[ pMax, ypred ] = max( P, [], 2 );
[ dummy, perm ] = sort( pMax, 'descend' );
subset = perm( 1:round( (1-nopredfrac) * nbtest ) );
ypreds=ypred(subset);
ytests=ytest(subset);


for i=1:nbclass
    ind=find(ytests==i);
    indn=find(ytests~=i);
    ytestaux=ytests;
    ytestaux(ind)=1;ytestaux(indn)=-1;
    ypredaux=zeros(size(ytests));
    ind=find(ypreds==i);
    indn=find(ypreds~=i);
    ypredaux(ind)=1;ypredaux(indn)=-1;
    [Conf,metric]=ConfusionMatrix(ypredaux,ytestaux,[1 -1]);
    fmeasureI(i)=metric.fmeasure;
    bcI(i)=metric.accuracy;
end;