%
% once all the experiments have been computed
% Figure 2, 3 and 4 can be obtained by this script
%

clear all
close all

nbitermax=20;
r=4 ;
N=100;
nbapp=100;
nbval=100;
nbtest=5000;
sigmas=1;
nbtasks=4;
NbCvec=5;
nbiter=10;
Cvec=logspace(-2,2,NbCvec);
path=['./resultats/']
%path=''
type={'nbapp' 'nbtasks' 'nbrel' 'dim'}
typefig= type{1};
ymin=0.05;
ymax=0.2;

switch typefig
    case 'nbapp'
        nbtasks=4;
        N=100;
        r=4;
        vec=[25:25:100];
        for it=1:length(vec)
            nbapp=vec(it);
            filename=['ToyProx' '-rel' int2str(r) '-dim' int2str(N) '-nbtask' int2str(nbtasks)...
                '-nbapp' int2str(nbapp) '-nbiter' int2str(nbitermax)]
            load([path filename])
            MSpar(it)=mean(Spars);
            MSparL1(it)=mean(SparsL1);
            MErr(it)=mean(Err);
            SErr(it)=std(Err);
            MErrL1(it)=mean(ErrL1);
            SErrL1(it)=std(ErrL1);
            MErr(it)=mean(Err);
            MErrEM(it)=mean(ErrEM);
            MErrEMB(it)=mean(ErrEMB);
            MErrB(it)=mean(ErrB);

            MErrL1(it)=mean(ErrL1);
            MErrL1EM(it)=mean(ErrL1EM);
            MErrL1EMB(it)=mean(ErrL1EMB);
            MErrL1B(it)=mean(ErrL1B);
            MErrPooledL1(it)=mean(ErrPooledL1);
            MErrSeparatedL1(it)=mean(ErrSeparatedL1);
            SErrPooledL1(it)=std(ErrPooledL1);
            SErrSeparatedL1(it)=std(ErrSeparatedL1);
            Mdfeat(it)=sum( (Err-ErrL1)>0);
            MFmeas(it)=mean(Fmeas);
            MFmeasL1(it)=mean(FmeasL1);
            MFmeasEM(it)=mean(FmeasEM);
            MFmeasL1EM(it)=mean(FmeasL1EM);
            MFmeasEMAdapt(it)=mean(FmeasEMAdapt);
            MFmeasL1EMAdapt(it)=mean(FmeasL1EMAdapt);

            Mdfmeas(it)=sum( (-Fmeas+FmeasL1)>0);
            [P(it),H(it)]=signrank(Err,ErrL1,0.05);
            for i=1:nbiter
                [prec(i),rec(i),FmeasSepSVM(i)]=evaluateSparsity(sum(Dsep{i}>seuil),1:r,seuil);
            end;
            MFmeasSepSVM(it)=mean(FmeasSepSVM);
                        MPsel{it}=Psel;
        end;

        h=plot(vec,MErrL1,'ro-.',vec,MErr,'bx-',vec,MErrEM,'kd--',...
            vec,MErrSeparatedL1,'gs:','LineWidth',2,'MarkerSize',8), hold on
        legend('L_1-L_2 Prox','L_p-L_2 Prox','L_p-L_2 Altern','L_1 SepSVM', 'Fonts',16);
        grid


        set(gcf,'color','white')
        xlabel('Nb Training examples','Fonts',16)
        ylabel('Test Error','Fonts',16)
        set(gca,'Fonts',16)

        title('r=4, d=100, T=4','Fonts',16)
        axis([0 125 0.05 0.2]);
        for it=1:length(vec)
            text(vec(it), MErrL1(it)+0.006, int2str(Mdfeat(it)),'Fonts',20);
        end;

        figure
        plot(vec,MFmeas,'bx-',vec,MFmeasEM,'kd--',vec,MFmeasEMAdapt,'mh-.',vec,MFmeasL1,'ro-.',...%,vec,MFmeasL1EMAdapt,'cp--',...
            'LineWidth',2,'MarkerSize',8), hold on
        set(gcf,'color','white')

        xlabel('Nb Training examples','Fonts',16)
        ylabel('F-measure','Fonts',16)
        set(gca,'Fonts',16)
        legend('L_p-L_2 Prox','L_p-L_2 Altern','L_p-L_2 Altern Ad','L_1-L_2 Prox','L_1-L_2 Altern Ad', 'Fonts',16);
        title('d=100, T=4, n=100','Fonts',16)
        axis([0 125 0.3 1]);
        grid
        for it=1:length(vec)
            text(vec(it), MFmeasL1(it)-0.04, int2str(Mdfmeas(it)),'Fonts',20);
        end;
    case 'nbtasks'
        r=4;
        N=100;
        nbapp=100;
        vec=[1 2 4 6 8 10];
        for it=1:length(vec)
            nbtasks=vec(it);
            filename=['ToyProx' '-rel' int2str(r) '-dim' int2str(N) '-nbtask' int2str(nbtasks)...
                '-nbapp' int2str(nbapp) '-nbiter' int2str(nbitermax)]
            load([path filename])
            MSpar(it)=mean(Spars);
            MSparL1(it)=mean(SparsL1);
            MErr(it)=mean(Err);

            MErr(it)=mean(Err);
            MErrEM(it)=mean(ErrEM);
            MErrEMB(it)=mean(ErrEMB);
            MErrB(it)=mean(ErrB);

            MErrL1(it)=mean(ErrL1);
            MErrL1EM(it)=mean(ErrL1EM);
            MErrL1EMB(it)=mean(ErrL1EMB);
            MErrL1B(it)=mean(ErrL1B);
            MErrPooledL1(it)=mean(ErrPooledL1);
            MErrSeparatedL1(it)=mean(ErrSeparatedL1);
            SErrPooledL1(it)=std(ErrPooledL1);
            SErrSeparatedL1(it)=std(ErrSeparatedL1);
            MErrL1(it)=mean(ErrL1);
            Mdfeat(it)=sum( (Err-ErrL1)>0);
            MFmeas(it)=mean(Fmeas);
            MFmeasL1(it)=mean(FmeasL1);
            [P(it),H(it)]=signrank(Err,ErrL1,'alpha',0.05);
        end;
        h=plot(vec,MErrL1,'ro-.',vec,MErr,'bx-',vec,MErrEM,'kd--',...
            vec,MErrSeparatedL1,'gs:','LineWidth',2,'MarkerSize',8), hold on
        legend('L_1-L_2 Prox','L_p-L_2 Prox','L_p-L_2 Altern','L_1 SepSVM', 'Fonts',16);
        set(gcf,'color','white')
        xlabel('Nb Tasks','Fonts',16)
        ylabel('Test Error (%)','Fonts',16)
        set(gca,'Fonts',16)

        title('r=4, d=100, n=100','Fonts',16)
        grid
        axis([0 12 0.05 0.2]);
        for it=1:length(vec)
            text(vec(it), MErrL1(it)+0.006, int2str(Mdfeat(it)),'Fonts',20);
        end;


    case 'nbrel'   % --- 3
        clear MSpar MSparL1 MErr MErrL1

        vec=[4 6 8 10 12 16 20];
        for it=1:length(vec)
            r=vec(it);
            filename=['ToyProx' '-rel' int2str(r) '-dim' int2str(N) '-nbtask' int2str(nbtasks)...
                '-nbapp' int2str(nbapp) '-nbiter' int2str(nbitermax) ]
            load([path filename])
            MSpar(it)=mean(Spars);
            MSparL1(it)=mean(SparsL1);
            MErr(it)=mean(Err); SErr(it)=std(Err);
            MErrL1(it)=mean(ErrL1);SErrL1(it)=std(ErrL1);

            MErr(it)=mean(Err);
            MErrEM(it)=mean(ErrEM);
            MErrEMB(it)=mean(ErrEMB);
            MErrB(it)=mean(ErrB);

            MErrL1(it)=mean(ErrL1);
            MErrL1EM(it)=mean(ErrL1EM);
            MErrL1EMB(it)=mean(ErrL1EMB);
            MErrL1B(it)=mean(ErrL1B);

            MErrPooledL1(it)=mean(ErrPooledL1);
            MErrSeparatedL1(it)=mean(ErrSeparatedL1);
            SErrPooledL1(it)=std(ErrPooledL1);
            SErrSeparatedL1(it)=std(ErrSeparatedL1);
            MFmeas(it)=mean(Fmeas);
            MFmeasL1(it)=mean(FmeasL1);
            MFmeasEM(it)=mean(FmeasEM);
            MFmeasL1EM(it)=mean(FmeasL1EM);
            MFmeasEMAdapt(it)=mean(FmeasEMAdapt);
            MFmeasL1EMAdapt(it)=mean(FmeasL1EMAdapt);
            Mdfeat(it)=sum( (Err-ErrL1)>0);
            Mdfmeas(it)=sum( (-Fmeas+FmeasL1)>0);
            %     MErrAn(it)=mean(ErrAn);
            [P(it),H(it)]=signrank(Err,ErrL1,'alpha',0.05);
            MPsel{it}=Psel;
            %             for i=1:nbiter
            %                 [prec(i),rec(i),FmeasSepSVM(i)]=evaluateSparsity(sum(Dsep{i}>seuil),1:r,seuil);
            %             end;
            %         MFmeasSepSVM(it)=mean(FmeasSepSVM);
        end;
        figure



        h=plot(vec,MErrL1,'ro-.',vec,MErr,'bx-',vec,MErrEM,'kd:'...
            ,vec,MErrSeparatedL1,'gs--','LineWidth',2,'MarkerSize',8), hold on
        legend('L_1-L_2 Prox','L_p-L_2 Prox', 'L_p-L_2 Altern' ,'L_1 SepSVM', 'Fonts',16);
        set(gcf,'color','white')
        xlabel('Nb of relevant variables r','Fonts',16)
        ylabel('Test Error','Fonts',16)
        set(gca,'Fonts',16)
        title('d=100, T=4, n=100','Fonts',16)
        axis([0 22 0.05 0.20]);

        grid
        for it=1:length(vec)
            text(vec(it), MErrL1(it)+0.006, int2str(Mdfeat(it)),'Fonts',20);
        end;

        figure
        plot(vec,MFmeas,'bx-',vec,MFmeasEM,'kd--',vec,MFmeasEMAdapt,'mh-.',vec,MFmeasL1,'ro-.',vec,MFmeasL1EMAdapt,'cp--',...
            'LineWidth',2,'MarkerSize',8), hold on

        legend('L_p-L_2 Prox','L_p-L_2 Altern','L_p-L_2 Altern Ad','L_1-L_2 Prox','L_1-L_2 Altern Ad', 'Fonts',16);

        set(gcf,'color','white')
        xlabel('Nb of relevant variables r','Fonts',16)
        ylabel('F-measure','Fonts',16)
        set(gca,'Fonts',16)

        title('d=100, T=4, n=100','Fonts',16)
        grid
        axis([0 22 0.3 1]);
        for it=1:length(vec)
            text(vec(it), MFmeasL1(it)-0.04, int2str(Mdfmeas(it)),'Fonts',20);
        end;

    case 'dim'
        clear MSpar MSparL1 MErr MErrL1
        nbtasks=4;nbapp=100;
        vec=[25:25:100];
        for it=1:length(vec)
            N=vec(it);
            filename=['ToyProx' '-rel' int2str(r) '-dim' int2str(N) '-nbtask' int2str(nbtasks)...
                '-nbapp' int2str(nbapp) '-nbiter' int2str(nbitermax)]
            load([path filename])

            MSpar(it)=mean(Spars);
            MSparL1(it)=mean(SparsL1);
            MErr(it)=mean(Err);
            MErrEM(it)=mean(ErrEM);
            MErrEMB(it)=mean(ErrEMB);
            MErrB(it)=mean(ErrB);

            MErrL1(it)=mean(ErrL1);
            MErrL1EM(it)=mean(ErrL1EM);
            MErrL1EMB(it)=mean(ErrL1EMB);
            MErrL1B(it)=mean(ErrL1B);

            MFmeas(it)=mean(Fmeas);
            MErrPooledL1(it)=mean(ErrPooledL1);
            MErrSeparatedL1(it)=mean(ErrSeparatedL1);
            SErrPooledL1(it)=std(ErrPooledL1);
            SErrSeparatedL1(it)=std(ErrSeparatedL1);
            % MFmeasL1(it)=mean(FmeasL1);
            Mdfeat(it)=sum( (Err-ErrL1)>0);

            [P(it),H(it)]=signrank(Err,ErrL1,'alpha',0.005);
        end;
        figure

        h=plot(vec,MErrL1,'ro-.',vec,MErr,'bx-',vec,MErrEM,'kd:',...
            vec,MErrSeparatedL1,'gs--','LineWidth',2,'MarkerSize',8), hold on

        legend('L_1-L_2 Prox','L_p-L_2 Prox', 'L_p-L_2 Altern','L_1 SepSVM', 'Fonts',16);



        xlabel('Dimension d ','Fonts',16)
        ylabel('Test Error','Fonts',16)
        % ylabel('','Fonts',16)
        set(gca,'Fonts',16)
        %legend('L_1-L_2','L_p-L_2', 'L_1 SepSVM', 'Fonts',16);
        title('r=4, T=4, n=100','Fonts',16)
        set(gcf,'color','white')
        grid
        axis([0 125 0.05 0.2]);
        for it=1:length(vec)
            text(vec(it), MErrL1(it)+0.006, int2str(Mdfeat(it)),'Fonts',20);
        end;
end;


% a lancer avec rel 
% figure(3)
% i=1;
% bar([1:4],histc(MPsel{i},pvec))
% axis([0 5 0 12]);
% set(gca,'Xtick',[1:4], 'XtickLabel',['0.20';'0.50';'0.75';'0.90'],'Fonts',16)
% set(gcf,'color','white');
% xlabel('p','Fonts',16)
% ylabel('Nb of selection over 20 trials','Fonts',16);
% if i==7
% title(['Nb of relevant variables = ' int2str(vec(i))],'Fonts',16);
% elseif i==1
%     title(['Nb of relevant variables = ' int2str(vec(i))],'Fonts',16);
% end;
